c-----------------------------------------------------------------
      program amde2famde
c
c  Derived from scan-amde.d.f written by JCD.
c
c  scan adiabatic oscillation modes
c-----------------------------------------------------------------
c-----------------------------------------------------------------
c-----------------------------------------------------------------
c  IMPORTANT: will only work for restricted set (nfmode = 3)
c-----------------------------------------------------------------
c-----------------------------------------------------------------
c-----------------------------------------------------------------
c
c  Double precision version
c  ++++++++++++++++++++++++
c
c  Dated 3/10/08
c
      implicit none
      integer nnin, n, i, lprev, nprev, l, nord, nm
      double precision frq
      character*40 fin, fout
      character*46 oneline
      double precision xin(5000),yin(6,5000),cs(50)
c
c  Get input and output files
c
      write(6,*) 'Enter input file'
      read(5,'(a)') fin
      write(6,*) 'Enter output file'
      read(5,'(a)') fout
c
c  Write header in output file
c
      open(3,file=fout,status="unknown")
      call wbheader(3)
c
      open(2,file=fin,status='old',form='unformatted')
c
      nm=0
      lprev = -1
      nprev = -1
c
c  read x
c
      read(2,end=50) nnin,(xin(n),n=1,nnin)
      write(3,*) nnin
      i = 0
      do 
        write(oneline,'(2(X,1pe22.15))') (xin(i+n),n=1,min(2,nnin-i))
        call fix(oneline)
        write(3,'(a46)') oneline
        i = i + 2
        if (i.ge.nnin) exit
      enddo
c
      write(6,130) fin
c
   10 continue
      read(2,end=50) cs,((yin(i,n),i=1,2),n=1,nnin)
c
      nm=nm+1
c
      l=cs(18)+0.5d0
      nord=cs(19)
      frq=1000.d0*cs(27)
      write(6,140) nm,l,nord,frq
c
c  The condition is to avoid writing duplicate eigenmodes
c
      if ((l.ne.lprev).or.(nord.ne.nprev)) then
        do i=0,48,2
          write(oneline,'(2(X,1pe22.15))') (cs(i+n),n=1,2)
          call fix(oneline)
          write(3,'(a46)') oneline
        enddo

        do i=1,nnin
          write(oneline,'(2(X,1pe22.15))') yin(1,i),yin(2,i)
          call fix(oneline)
          write(3,'(a46)') oneline
        enddo
      endif
      lprev = l
      nprev = nord
c
      go to 10
c
   50 continue
      close(2)
      close(3)
      stop
c
  130 format(' File name: ',a//' n, l, order, frequency (microHz)'/)
  140 format(3i5,f10.3)
      end

c---------------------------------------------------------------------------
c  Fortran has the obnoxious habit of dropping out the letter "E" in
c  a number with exponent when the exponent takes up 3 digits.
c  This subroutine fixes this by hand.
c---------------------------------------------------------------------------
      subroutine fix(oneline)
      
      implicit none
      character*(46) oneline
      
      if (oneline(20:20).eq."-") oneline(19:19)="E"
      if (oneline(43:43).eq."-") oneline(42:42)="E"
      if (oneline(20:20).eq."+") oneline(19:19)="E"
      if (oneline(43:43).eq."+") oneline(42:42)="E"
      
      end subroutine
c---------------------------------------------------------------------------
c
c     example of how to write the 'ab' / 'ba' byte order stamp from
c     a fortran prgram
c
c     @(#)wbheader.f	1.1 95/07/25 22:23:32 SGK
c
c---------------------------------------------------------------------------
      subroutine wbheader(iu)
      integer iu
      integer*2 iab
      character*2 c
      character term
      equivalence (iab,c)
c
c     24930 is 'ab'
c
      data iab /24930/
c
c     term is {ctrl-L}
c
      term = char(12)
c      
      write(iu,1000) c
      write(iu,'(a)') "User-definable character header"
      write(iu,'(a)') term
      write(iu,'(a)') "model: <time stamp for stellar model>"
      write(iu,'(a)') "version: <version of the pulsation code>"
      write(iu,'(a)') term
      write(iu,'(a)')
     & "Created 'date and time' on 'host' by 'user' for 'project'"
      write(iu,'(a)') term
      write(iu,'(a)') term
      write(iu,'(a)') term

 1000 format('WB-2.1 JCD-famde v1.0 ',a2)
      end
